import pygtk
pygtk.require('2.0')
import gtk
import ItemWindow

class GUI:	
	def __init__(self, dba):
		self.level = 0
		self.dba = dba
		
		
        	self.window = gtk.Window(gtk.WINDOW_TOPLEVEL)
		
		box = gtk.HBox()
		
		
		self.swindow = gtk.ScrolledWindow()
		self.swindow.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
		#self.window.fullscreen()
		self.window.connect("destroy", self.destroy)
		
		self.model = gtk.ListStore(str, gtk.gdk.Pixbuf)
		self.model_menu = gtk.ListStore(str, gtk.gdk.Pixbuf)
		
		self.thumb_view = gtk.IconView()
		self.thumb_view.set_model(self.model)
		self.thumb_view.set_text_column(0)
		self.thumb_view.set_pixbuf_column(1)
		self.thumb_view.set_columns(3) 	
		self.thumb_view.set_item_width(180)
		#self.thumb_view.set_row_spacing(40)
		self.thumb_view.connect("activate-cursor-item", self.handler)
		self.thumb_view.connect("item-activated", self.handler)
		self.swindow.add(self.thumb_view)
		
		self.menu = gtk.IconView()
		self.menu.set_model(self.model_menu)
		self.menu.set_text_column(0)
		self.menu.set_pixbuf_column(1)
		self.menu.set_columns(1) 	
		self.menu.set_item_width(140)
		self.menu.set_row_spacing(40)
		self.menu.connect("activate-cursor-item", self.menu_handler)
		self.menu.connect("item-activated", self.menu_handler)
		
		box.set_homogeneous(False)
		self.menu.set_size_request(150,100)
		box.pack_start(self.menu,expand=False)
		box.pack_start(self.swindow,expand=True)
		box.show()
		
		self.window.add(box)
		
		self.thumb_view.show()
		self.menu.show()
		self.swindow.show()
        	self.window.show()
		
		self.database_view()
		self.menu_show()
	
	
	def menu_show(self):
		self.model_menu.clear()
		if self.level == 0:
			pixbuf = gtk.gdk.pixbuf_new_from_file_at_size("exit.png", 48, 48)
			self.model_menu.append(["Exit", pixbuf]) 
			pixbuf = gtk.gdk.pixbuf_new_from_file_at_size("save.png", 48, 48)
			self.model_menu.append(["Save", pixbuf]) 
			pixbuf = gtk.gdk.pixbuf_new_from_file_at_size("add.png", 48, 48)
			self.model_menu.append(["New Database", pixbuf]) 
			pixbuf = gtk.gdk.pixbuf_new_from_file_at_size("search.png", 48, 48)
			self.model_menu.append(["Search", pixbuf]) 
		elif self.level == 1:
			pixbuf = gtk.gdk.pixbuf_new_from_file_at_size("back.png", 48, 48)
			self.model_menu.append(["Back", pixbuf]) 
			pixbuf = gtk.gdk.pixbuf_new_from_file_at_size("minus.png", 48, 48)
			self.model_menu.append(["Remove Database", pixbuf]) 
			pixbuf = gtk.gdk.pixbuf_new_from_file_at_size("add.png", 48, 48)
			self.model_menu.append(["New Category", pixbuf]) 
		elif self.level == 2:
			pixbuf = gtk.gdk.pixbuf_new_from_file_at_size("back.png", 48, 48)
			self.model_menu.append(["Back", pixbuf]) 
			pixbuf = gtk.gdk.pixbuf_new_from_file_at_size("minus.png", 48, 48)
			self.model_menu.append(["Remove Category", pixbuf]) 
			pixbuf = gtk.gdk.pixbuf_new_from_file_at_size("settings.png", 48, 48)
			self.model_menu.append(["Settings", pixbuf]) 
			pixbuf = gtk.gdk.pixbuf_new_from_file_at_size("add.png", 48, 48)
			self.model_menu.append(["New Item", pixbuf]) 

			
	def database_view(self):
		self.level = 0
		self.model.clear()
		self.menu_show()
		for db in self.dba.database_list:
			pixbuf = gtk.gdk.pixbuf_new_from_file_at_size("database.png", 64, 64)
			self.model.append([db.get_name(), pixbuf]) 
 
		
	def category_view(self, db):
		self.level = 1
		self.model.clear()
		self.menu_show()
		for category in db.category_list:
			pixbuf = gtk.gdk.pixbuf_new_from_file_at_size("category.png", 64, 64)
			self.model.append([category.get_name(), pixbuf]) 
					
					
					
	def item_view(self, category):
		self.level = 2
		self.model.clear()
		self.menu_show()
		for item in category.item_list:
			pixbuf = gtk.gdk.pixbuf_new_from_file_at_size("item.png", 64, 64)
			self.model.append([item.get_name(), pixbuf]) 
			
	def destroy(self, widget, data=None):
		gtk.main_quit()
		
		
	def menu_handler(self, widget, data=None):
		if self.level == 0:
			if data[0] == 0: gtk.main_quit()
			elif data[0] == 1: self.dba.save()
			elif data[0] == 2: self.show_dialog()

		elif self.level == 1:
			if data[0] == 0:
				self.database_view()
			elif data[0] == 1:
				self.show_cdialog("Delete %s?" % self.cur_database.get_name())
			elif data[0] == 2:
				self.show_dialog()
		elif self.level == 2:
			if data[0] == 0:
				self.category_view(self.cur_database)
			elif data[0] == 1:
				self.show_cdialog("Delete %s?" % self.cur_category.get_name())
			elif data[0] == 2:
				# category settings window
				return 0
			elif data[0] == 3:
				self.show_dialog()
	
	
	def handler(self, widget, data=None):
		if self.level == 0:
			self.category_view(self.dba.database_list[data[0]])
			self.cur_database = self.dba.database_list[data[0]]#.get_name()
		elif self.level == 1:
			self.cur_category = self.cur_database.category_list[data[0]]
			self.item_view(self.cur_category)
		elif self.level == 2:
			ItemWindow.ItemWindow(self.cur_category.item_list[data[0]], self.dba)
			

	def show_dialog(self):
		titles = ['Add new database', 'Add new category','Add new item']
		msg = titles[self.level]
		self.entry = gtk.Entry()
		button1 = gtk.Button("Save")
		button2 = gtk.Button("Cancel")
		label = gtk.Label(msg)
		self.dialog = gtk.Dialog() #'New database', self.window, gtk.DIALOG_MODAL | gtk.DIALOG_DESTROY_WITH_PARENT, ("Add", 0, gtk.STOCK_CLOSE, gtk.RESPONSE_CLOSE))
		self.dialog.vbox.pack_start(label)
		self.dialog.vbox.pack_start(self.entry)
		self.dialog.vbox.pack_start(button1)
		self.dialog.vbox.pack_start(button2)
		#self.dialog.set_title(msg)
		
		button1.connect("clicked", self.on_button1_clicked)
		button1.show()
		
		button2.connect("clicked", self.on_button2_clicked)
		button2.show()
				
		label.show()
		
		self.entry.show()
		self.dialog.show()
		
    	def on_button1_clicked(self, widget):
		if len(self.entry.get_text()) > 0:
			if self.level == 0: 
				self.dba.database_add(self.entry.get_text())
				self.database_view()
			if self.level == 1: 
				self.cur_database.category_add(self.entry.get_text())
				self.category_view(self.cur_database)
			if self.level == 2: 
				self.cur_category.item_add(self.entry.get_text())
				self.item_view(self.cur_category)	
			self.dialog.destroy()
			
		
	def on_button2_clicked(self, widget):	
		self.dialog.destroy()
		
		
	def show_cdialog(self, msg="?"):
		button1 = gtk.Button("OK")
		button2 = gtk.Button("Cancel")
		label = gtk.Label(msg)
		self.cdialog = gtk.Dialog() 
		self.cdialog.vbox.pack_start(label)
		self.cdialog.vbox.pack_start(button1)
		self.cdialog.vbox.pack_start(button2)
		#self.dialog.set_title(msg)
		
		button1.connect("clicked", self.on_confirm)
		button1.show()
		
		button2.connect("clicked", self.on_cancel)
		button2.show()
				
		label.show()

		self.cdialog.show()
		
    	def on_confirm(self, widget):	
		self.cdialog.destroy()
		if self.level == 1:
			self.dba.database_delete(self.cur_database.get_name()) # delete database
			self.database_view()	
		if self.level == 2:
			print self.cur_category.get_name()
			self.cur_database.category_delete(self.cur_category.get_name())
			self.category_view(self.cur_database)
		if self.level == 3:
			self.cur_category.item_delete(self.cur_category.get_name())
			self.category_view(self.cur_database)
			
	def on_cancel(self, widget):
		self.cdialog.destroy()
		
    	def main(self):
        	gtk.main()

