import Field

class Item:
	
	def __init__(self, name, defaults):
		self.name = name
		self.field_list = []
		for field in defaults:
			self.field_add(field.get_name(), field.get_type(), field.get_value())
		
		
	def get_name(self):
		return self.name
	
	
	def set_name(self, name):
		self.name = name
		
		
	def to_string(self):
		print "----> %s" % self.name
		for field in self.field_list:
			field.to_string()

	
	
	def field_add(self, name, field_type, value):
		if not self.field_present(name):
			field = Field.Field(name, field_type, value)
			self.field_list.append(field)
	
	
	def field_delete(self, name):
		if self.field_present(name):
			self.field_list.remove(self.field_select(name))
	
	
	def field_present(self, name):
		for field in self.field_list:
			if field.get_name() == name:
				return True
		return False

	
	def field_select(self, name):
		for field in self.field_list:
			if field.get_name() == name:
				return field
		return False
		
		
	def field_list(self):
		return self.field_list
		